// Colr Pickr - Actionscript Code by Jim Bumgardner
//

stop();

kRadiansToDegrees = 180/Math.PI;
kDegreesToRadians = Math.PI/180;

kSliderHeight = 256;

pickSat = .5+Math.random()*.5;
pickHue = Math.random();
pickVal = .5 + Math.random()*.5;
thresh = 10000;

lastSat = -1;
lastHue = -1;
lastVal = -1;
pageNbr = 0;

sdb = [];

var ratioLoaded = 0;

// These two routines can be modified to make the colr pickr work
// with other image archives...

GetThumbUrl = function(imgRec)
{
  return 'http://static.flickr.com/' + 
					imgRec.server + '/' + imgRec.id + '_' + imgRec.secret + '_s.jpg';
}

GetExternalUrl = function(imgRec)
{
	return 'http://www.flickr.com/photos/' + imgRec.owner + 
					'/' + imgRec.id;  
  // add this if you want to link to a photo in a group pool
  //  + '/in/pool-' + poolname + '/';
}

_root.createEmptyMovieClip('slider', 1);
slider.createEmptyMovieClip('slot', 1);
slider.createEmptyMovieClip('knob', 2);

matrix1 = {matrixType:"box", x:-15, y:-15, w:30, h:30, r:3*Math.PI/2};
matrix2 = {matrixType:"box", x:-4, y:0, w:8, h:kSliderHeight, r:Math.PI/2};
colors = [0x000000,0xFFFFFF];
alphas = [100,100];
ratios = [0, 0xFF];
slider._x = picker._x + 160;
slider._y = picker._y - kSliderHeight/2;
slider.knob.beginGradientFill("linear", colors, alphas,ratios, matrix1);
slider.knob.drawCircle(0,0,15);
slider.knob.endFill();
slider.slot.beginGradientFill("linear", colors, alphas,ratios, matrix2);
// slider.slot.lineStyle(1,0x777777,100);
slider.slot.moveTo(-3,0);
slider.slot.lineTo(3,0);
slider.slot.lineTo(3,kSliderHeight);
slider.slot.lineTo(-3,kSliderHeight);
slider.slot.lineTo(-3,0);
slider.slot.endFill();

slider._visible = false;
slider.knob._y = pickVal*kSliderHeight;

redrawPicker = function()
{
	for (var i = 0; i < m; ++i)
	{
		var mc = picker["s_"+i];
		mc.clr.setRGB(HSVtoRGB(mc.a, mc.d, pickVal));
	}
}

progressPicker = function()
{
	var mm = int(m*ratioLoaded);
	for (var i = Math.min(m, mm+20); i >= 0; --i)
	{
		var mc = picker["s_"+i];
		mc._alpha = i >= mm? 100 : 100-(i-mm)*100/20;
		mc._visible = true;
	}
}

_root.onEnterFrame = function()
{
	if ( _root.getBytesTotal() == 0)
		ratioLoaded = 0;
	else {
		var t = _root.getBytesLoaded() / _root.getBytesTotal();
		ratioLoaded += (t - ratioLoaded)*.2;
	}
	progressPicker();
	if (_root._totalframes > 0 && ratioLoaded > .95 &&
		_root._framesloaded == _root._totalframes)
	{
		ratioLoaded = 1;
		progressPicker();
		delete this.onEnterFrame;
		slider._visible = true;
		gotoAndStop(2);
	}
}


MovieClip.prototype.drawCircle = function(x,y,radius)
{
	var r = radius;
	var n= 8;
	
	var theta = 45*kDegreesToRadians;
	var cr = radius/Math.cos(theta/2);
	var angle = bA*kDegreesToRadians;
	var cangle = angle-theta/2;
	
	this.moveTo(x+r, y);
	for (var i=0;i < n;i++) 
	{
		angle += theta;
		cangle += theta;
		var endX = r*Math.cos (angle);
		var endY = r*Math.sin (angle);
		var cX = cr*Math.cos (cangle);
		var cY = cr*Math.sin (cangle);
		this.curveTo(x+cX,y+cY, x+endX,y+endY);
	}
}


HSVtoRGB = function(h,s,v)
{
	var	r,g,b;
	h *= 360;

	if (s == 0) {
		r = g = b = v;
	}
	else {
		if (h >= 360.0)
			h = 0;
		else
			h /= 60.0;
		var i = Math.floor(h);
		var f = h - i;
		var m = v*(1-s);
		var n = v*(1-s*f);
		var k = v*(1-s*(1-f));
		switch (i) {
		case 0:
			r = v;
			g = k;
			b = m;
			break;
		case 1:
			r = n;
			g = v;
			b = m;
			break;
		case 2:
			r = m;
			g = v;
			b = k;
			break;
		case 3:
			r = m;
			g = n;
			b = v;
			break;
		case 4:
			r = k;
			g = m;
			b = v;
			break;
		default:
			r = v;
			g = m;
			b = n;
			break;
		}
	}
	r *= 255;
	g *= 255;
	b *= 255;
	return (r << 16) | (g << 8) | b;
}

function drawSprite()
{
	this.clear();
  	mc.beginFill(0x000000, 100);
	mc.drawCircle(0,0,this.r);
    mc.endFill()
}

doFilter = function(thresh, ary)
{
	var rgb = HSVtoRGB(pickHue, pickSat, pickVal);
	var r = (rgb >> 16) & 0xFF;
	var g = (rgb >> 8) & 0xFF;
	var b = (rgb >> 0) & 0xFF;

	var res = [];
	// var st = getTimer();
	// loop thru array and set distance from desired color
	for (var i = ary.length-1; i >= 0; --i)
	{
		var img = ary[i];
		var diffr = img.r - r;
		var diffg = img.g - g;
		var diffb = img.b - b;
		var dist2 = (diffr*diffr + diffg*diffg + diffb*diffb);
		if (dist2 < thresh)
		{
			img.dist2 = dist2;
			res.push(img);
		}
	}
	// var et = getTimer() - st;
	// trace("Filter: " + et + ", " + res.length + " selected");
	return res;
}

doRefilter = function(thresh, ary)
{
	// st = getTimer();
	res = [];
	for (var i = ary.length-1; i >= 0; --i)
	{
		var img = ary[i];
		if (img.dist2 < thresh)
			res.push(img);
	}
	// et = getTimer() - st;
	// trace(" re Filter: " + et + ", " + res.length + " selected");
	return res;
}

doPick = function()
{
	if (Math.abs(lastVal - pickVal) < 2/256 &&
		Math.abs(lastSat - pickSat) < 2/256 &&
		Math.abs(lastHue - pickHue) < 2/256)
	{
		pageNbr++;
		if (12*pageNbr >= sdb.length)
			pageNbr = 0;
		// trace("Page up");
	}
	else {
		pageNbr= 0;
		lastHue = pickHue;
		lastSat = pickSat;
		lastVal = pickVal;
		sdb = doFilter(thresh, imgdb);
	
		while (sdb.length < 12) 
		{
			thresh *= 2;
			sdb = doFilter(thresh, imgdb)
		}
	
		while (sdb.length > 300 && thresh > 256) 
		{
			thresh /= 2;
			sdb = doRefilter(thresh, sdb);
		}
		// sort on this field
		sdb.sort(function(a,b) { return a.dist2 - b.dist2;} );
	}
	
	// create 11 URLS and trace them, based on first N movies in array
	for (var i = 0; i < 12; ++i) 
	{
		var colorIdx = i+pageNbr*12;
		var mc = _root['m'+i];
		if (colorIdx < sdb.length) 
		{
			var url = GetThumbUrl(sdb[colorIdx]);
			// mc._visible = true;
			mc.isLoading = true;
			mc.loadee.loadMovie(url);
			outroMovie(mc);
			// mc._visible = false;
		}
		else {
			outroMovie(mc);
			// mc._visible = false;
		}
	}
}

outroMovie = function(mc)
{
	mc.ts = 200;
	mc.ta = 0;
	mc.tv = 0;
	mc.speed = .1;
	mc.onEnterFrame = function()
	{
		this.tv += this.speed;
		var ds = (this.ts - this._xscale)*.2;
		var da = (this.ta - this._alpha)*.2;
		this._xscale = 100+(this.ts-100)*this.tv;
		this._yscale = this._xscale;
		this._alpha = 100+(-100)*this.tv;
		if (this.tv >= 1)
		{
			delete this.onEnterFrame;
			this._visible = false;
		}
	}
}

debutMovie = function(mc)
{
	mc._xscale = 0;
	mc._yscale = 0;
	mc._alpha = 100;
	mc._visible = true;
	mc.ts = 100;
	mc.tv = 0;
	mc.stiffK = .6;
	mc.dampK = .5;
	mc.onEnterFrame = function()
	{
		this.tv += (this.ts - this._xscale)*this.stiffK;
		this.tv *= this.dampK;
		this._xscale += this.tv;
		this._yscale += this.tv;
		if (Math.round(this._xscale) == this.ts &&
		    Math.round(this.tv) == 0)
		{
			this._xscale = this._yscale = this.ts;
			delete this.onEnterFrame;
		}
	}
}

myGetURL = function(i)
{
	var colorIdx = i+pageNbr*12;
	var url = GetExternalUrl(sdb[colorIdx]);
	getURL(url, "flickr");
}
stop();


// SETUP
//
// This routine draws the colored spots within the color wheel
// The dots are arranged in a fibonacci spiral
//
var m = 200; 				            // number of sprites
var rad = 240/2;	              // radius of outer circle
var phi = (Math.sqrt(5)+1)/2-1; // golden ratio
var ga = 	phi*2*Math.PI;				// golden angle used in plant phyllotaxis
var asmall = (Math.PI*rad*rad)/m;
var R = Math.sqrt((rad*rad)/m); // also sqrt(asmall/PI);
var kMaxOffset = .8;
var cumA = 0; // cumulative area

for (var i = 0; i < m; ++i)
{
		var a = i*ga;			// angle of phyllotaxy
		var ir = i/(m-1); // i as a ratio
	  var xo = asmall*kMaxOffset*2*ir - asmall*kMaxOffset; // area offset of this nodule
	  var areai = asmall+xo;                           // area of this nodule
	  var radi = Math.sqrt(areai/Math.PI);             // radius of this nodule
	  var radcum = Math.sqrt(cumA/Math.PI);            // radius of cumulative area
		cumA += areai;
		var mc = picker.createEmptyMovieClip("s_"+i, i+1);
		mc._x = Math.cos(a) * radcum;
		mc._y = Math.sin(a) * radcum;
		mc.a = a/(2*Math.PI);
		mc.a -= Math.floor(mc.a);
		mc.d = radcum/rad;
		mc.n = i;
		mc.r = Math.max(7,radi*1.25);
		mc.drawSprite = drawSprite;
		mc.drawSprite();
		mc.clr = new Color(mc);
		mc.clr.setRGB(HSVtoRGB(mc.a, mc.d, pickVal));
		mc.onEnterFrame = colorSprite;
		mc._visible = false;
}

for (var i = 0; i < 12; ++i) 
{
	var mc = _root['m'+i];
	mc._visible = false
	mc.n = i;
}

changeVal = function()
{
	pickVal = this._y/kSliderHeight;
	redrawPicker();
}

slider.knob.onPress = function()
{
	this.startDrag(false, 0, 0, 0, kSliderHeight);
	this.onEnterFrame = changeVal;
}

slider.knob.onRelease = slider.knob.onReleaseOutside = function()
{
	this.stopDrag();
	delete this.onEnterFrame;
	doPick();
}

picker.onPress = function()
{
	// determine desired color
	var dy = _root._ymouse - picker._y;
	var dx = _root._xmouse - picker._x;
	var d = Math.sqrt(dy*dy+dx*dx)/rad;
	var a = (Math.atan2(dy,dx) + 2*Math.PI)/(2*Math.PI);
	a -= Math.floor(a);
	d = Math.max(0, Math.min(1, d));
	pickHue = a;
	pickSat = d;
	doPick();
}

